#ifndef dud4_events_hh
#define dud4_events_hh

#include <string>

typedef enum
{
	E_NONE = 0,
	E_GLOBAL,
	E_INFORM
} eventtype;

class event
{
	eventtype type;
public:
	event(eventtype t) : type(t)
	{
	}
	virtual ~event()
	{
	}
	virtual string getdata(const string &) const = 0;
	inline eventtype what() const { return type; }
};

class globalevent : public event
{
	string s;
public:
	globalevent(const string &msg) : event(E_GLOBAL), s(msg)
	{
	}
    virtual string getdata(const string &) const
    {
    	return s;
    }
};

class informevent : public event
{
	string nick, msg;
public:
	informevent(const string &n, const string &m) : event(E_INFORM), nick(n), msg(m)
	{
	}
    virtual string getdata(const string &s) const
    {
    	if(s == "name")return nick;
    	return msg;
    }
};

#endif
